=== debian/changelog ===
regina-normal (6.0~alpha1-0ubuntu3) groovy; urgency=medium

  * Skip tests on armhf for now. Segfaults, see https://pad.lv/1882228

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 05 Jun 2020 11:07:20 +0100

regina-normal (6.0~alpha1-0ubuntu1) groovy; urgency=medium

  * New upstream release.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 01 Jun 2020 14:39:54 +0100

regina-normal (5.1-6ubuntu3) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 25 Mar 2020 18:36:28 +0100

regina-normal (5.1-6ubuntu2) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 21:30:36 +0000
